//
//            ̼(BSC)Ա
//            Baby Fox Simple Class
//
//    ̱ȨʹȨг򰮺
//
//                useful functions
//

#include <windows.h>
#include "FStack.h"
#include "FString.h"

void EnumFilesEx(char *path, char *filter, bool EnumFilesExProc(char *filename, void *Param), void *Param)
{
    FStack<FString> sDirectory;
    sDirectory.Push(path);

    do
    {
        FString sName=sDirectory.Pop();
        if(sName[sName.GetLength()-1]!='\\')
            sName+="\\";

        WIN32_FIND_DATA myData;
        HANDLE myHandle=FindFirstFile(sName+filter, &myData);
        BOOL NotFinished=(myHandle!=INVALID_HANDLE_VALUE);

        while(NotFinished)
        {
            if(strcmp(myData.cFileName,".")!=0&&strcmp(myData.cFileName,"..")!=0)
            {
                if((myData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)==FILE_ATTRIBUTE_DIRECTORY)
                    sDirectory.Push(sName+myData.cFileName);
                else
                {
                    if(!EnumFilesExProc(sName+myData.cFileName, Param))
                        return;
                }
            }

            NotFinished=FindNextFile(myHandle,&myData);
        }
        FindClose(myHandle);
    }
    while(sDirectory.GetCount());
}

bool __EnumProc(char *path, void *Param)
{
    return ((bool (*)(char *))Param)(path);
}

void EnumFiles(char *path, bool EnumFilesProc(char *filename))
{
    EnumFilesEx(path, "*.*", __EnumProc, (void *)(EnumFilesProc));
}
